# coding: utf-8

"""
    Computebench Service API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from do_sdk_platform.models.fsx_storage_type import FSXStorageType
from do_sdk_platform.models.requested_cloud_provider_input import RequestedCloudProviderInput
from do_sdk_platform.models.shared_volume_type import SharedVolumeType
from typing import Optional, Set
from typing_extensions import Self

class CreateFileVolumeDto(BaseModel):
    """
    CreateFileVolumeDto
    """ # noqa: E501
    cloud_provider: RequestedCloudProviderInput = Field(description="The requested Cloud Provider for the resource", alias="cloudProvider")
    name: StrictStr = Field(description="The name of the volume, assigned by the user")
    user_assigned_id: StrictStr = Field(description="The id assigned by the user for the volume, used for mounting the volume", alias="userAssignedId")
    summary: StrictStr = Field(description="User provided summary of what the volume is for")
    type: SharedVolumeType
    size_gb: Union[StrictFloat, StrictInt] = Field(description="The size of the volume", alias="sizeGb")
    throughput: Optional[FSXStorageType] = None
    cluster_id: StrictStr = Field(description="The ID of the cluster to deploy the volume to", alias="clusterId")
    __properties: ClassVar[List[str]] = ["cloudProvider", "name", "userAssignedId", "summary", "type", "sizeGb", "throughput", "clusterId"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of CreateFileVolumeDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of cloud_provider
        if self.cloud_provider:
            _dict['cloudProvider'] = self.cloud_provider.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of CreateFileVolumeDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "cloudProvider": RequestedCloudProviderInput.from_dict(obj["cloudProvider"]) if obj.get("cloudProvider") is not None else None,
            "name": obj.get("name"),
            "userAssignedId": obj.get("userAssignedId"),
            "summary": obj.get("summary"),
            "type": obj.get("type"),
            "sizeGb": obj.get("sizeGb"),
            "throughput": obj.get("throughput"),
            "clusterId": obj.get("clusterId")
        })
        return _obj


