# coding: utf-8

"""
    Computebench Service API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from do_sdk_platform.models.described_external_entity_object import DescribedExternalEntityObject
from do_sdk_platform.models.external_entity_object import ExternalEntityObject
from do_sdk_platform.models.hardware_requirements_object import HardwareRequirementsObject
from typing import Optional, Set
from typing_extensions import Self

class OperatingSystemObject(BaseModel):
    """
    OperatingSystemObject
    """ # noqa: E501
    authors: List[ExternalEntityObject]
    created: Optional[StrictStr]
    description: Optional[StrictStr]
    family_id: StrictStr = Field(alias="familyId")
    icon: StrictStr
    license: Optional[DescribedExternalEntityObject]
    location: StrictStr
    name: StrictStr
    publication_references: List[ExternalEntityObject] = Field(alias="publicationReferences")
    requirements: HardwareRequirementsObject
    resource_links: List[ExternalEntityObject] = Field(alias="resourceLinks")
    summary: StrictStr
    type_id: StrictStr = Field(alias="typeId")
    use_case_ids: List[StrictStr] = Field(alias="useCaseIds")
    variant_tags: List[StrictStr] = Field(alias="variantTags")
    use_case_names: List[StrictStr] = Field(alias="useCaseNames")
    version: StrictStr
    __properties: ClassVar[List[str]] = ["authors", "created", "description", "familyId", "icon", "license", "location", "name", "publicationReferences", "requirements", "resourceLinks", "summary", "typeId", "useCaseIds", "variantTags", "useCaseNames", "version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OperatingSystemObject from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in authors (list)
        _items = []
        if self.authors:
            for _item_authors in self.authors:
                if _item_authors:
                    _items.append(_item_authors.to_dict())
            _dict['authors'] = _items
        # override the default output from pydantic by calling `to_dict()` of license
        if self.license:
            _dict['license'] = self.license.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in publication_references (list)
        _items = []
        if self.publication_references:
            for _item_publication_references in self.publication_references:
                if _item_publication_references:
                    _items.append(_item_publication_references.to_dict())
            _dict['publicationReferences'] = _items
        # override the default output from pydantic by calling `to_dict()` of requirements
        if self.requirements:
            _dict['requirements'] = self.requirements.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in resource_links (list)
        _items = []
        if self.resource_links:
            for _item_resource_links in self.resource_links:
                if _item_resource_links:
                    _items.append(_item_resource_links.to_dict())
            _dict['resourceLinks'] = _items
        # set to None if created (nullable) is None
        # and model_fields_set contains the field
        if self.created is None and "created" in self.model_fields_set:
            _dict['created'] = None

        # set to None if description (nullable) is None
        # and model_fields_set contains the field
        if self.description is None and "description" in self.model_fields_set:
            _dict['description'] = None

        # set to None if license (nullable) is None
        # and model_fields_set contains the field
        if self.license is None and "license" in self.model_fields_set:
            _dict['license'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OperatingSystemObject from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "authors": [ExternalEntityObject.from_dict(_item) for _item in obj["authors"]] if obj.get("authors") is not None else None,
            "created": obj.get("created"),
            "description": obj.get("description"),
            "familyId": obj.get("familyId"),
            "icon": obj.get("icon"),
            "license": DescribedExternalEntityObject.from_dict(obj["license"]) if obj.get("license") is not None else None,
            "location": obj.get("location"),
            "name": obj.get("name"),
            "publicationReferences": [ExternalEntityObject.from_dict(_item) for _item in obj["publicationReferences"]] if obj.get("publicationReferences") is not None else None,
            "requirements": HardwareRequirementsObject.from_dict(obj["requirements"]) if obj.get("requirements") is not None else None,
            "resourceLinks": [ExternalEntityObject.from_dict(_item) for _item in obj["resourceLinks"]] if obj.get("resourceLinks") is not None else None,
            "summary": obj.get("summary"),
            "typeId": obj.get("typeId"),
            "useCaseIds": obj.get("useCaseIds"),
            "variantTags": obj.get("variantTags"),
            "useCaseNames": obj.get("useCaseNames"),
            "version": obj.get("version")
        })
        return _obj


