# coding: utf-8

"""
    Computebench Service API

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from do_sdk_platform.models.file_volume_configuration_dto import FileVolumeConfigurationDto
from do_sdk_platform.models.volumestatus import VOLUMESTATUS
from typing import Optional, Set
from typing_extensions import Self

class VolumeDto(BaseModel):
    """
    VolumeDto
    """ # noqa: E501
    user_assigned_id: StrictStr = Field(description="The id assigned by the user for the volume", alias="userAssignedId")
    name: StrictStr = Field(description="The name of the volume assigned by the user")
    created_by: StrictStr = Field(description="DRN of the user who created the volume", alias="createdBy")
    configuration: FileVolumeConfigurationDto = Field(description="Configuration options for the volume")
    status: VOLUMESTATUS
    drn: StrictStr = Field(description="DRN for the Volume")
    summary: StrictStr = Field(description="User given summary describing the volume")
    cluster_id: Optional[StrictStr] = Field(description="ID of the cluster the volume is attached to", alias="clusterId")
    created_at: datetime = Field(description="Date the resource was created at", alias="createdAt")
    updated_at: datetime = Field(description="Date the resource was last updated at", alias="updatedAt")
    __properties: ClassVar[List[str]] = ["userAssignedId", "name", "createdBy", "configuration", "status", "drn", "summary", "clusterId", "createdAt", "updatedAt"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of VolumeDto from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of configuration
        if self.configuration:
            _dict['configuration'] = self.configuration.to_dict()
        # set to None if cluster_id (nullable) is None
        # and model_fields_set contains the field
        if self.cluster_id is None and "cluster_id" in self.model_fields_set:
            _dict['clusterId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of VolumeDto from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "userAssignedId": obj.get("userAssignedId"),
            "name": obj.get("name"),
            "createdBy": obj.get("createdBy"),
            "configuration": FileVolumeConfigurationDto.from_dict(obj["configuration"]) if obj.get("configuration") is not None else None,
            "status": obj.get("status"),
            "drn": obj.get("drn"),
            "summary": obj.get("summary"),
            "clusterId": obj.get("clusterId"),
            "createdAt": obj.get("createdAt"),
            "updatedAt": obj.get("updatedAt")
        })
        return _obj


